import themidibus.*; //Import the library

MidiBus mBus; // The MidiBus
int instrument = 0;
void setup() {
  size(400, 400);
  background(0);
  MidiBus.list();
  mBus = new MidiBus(this, -1, "Microsoft GS Wavetable Synth");
  // mBus = new MidiBus(this, -1, "Java Sound Synthesizer");
  // mBus = new MidiBus(this, -1, "SimpleSynth virtual input");
  // mBus = new MidiBus(this, -1, "Bus 1");
  noLoop();
}

void draw() {
  background(0);

  byte data[] = new byte[2];
  data[0] = (byte)0xC0; // C0hex = MIDI program change
  data[1] = (byte)0; // 0 = Acoustic Grand Piano
  // data[1] = (byte)55; // 55 = Orchesta Hit
  mBus.sendMessage(data);

  print("\n");

  int [] note = new int[7];

  for (int i = 0; i < note.length; i++)
    note[i] = (7 * i + 5) % 12;

  print("\n");
  for (int i = 0; i < note.length; i++)
    print(note[i] + ", ");

  print("\n");

  // Bubble Sort 
  for (int i = 0; i < note.length - 1; i++) {
    for (int j = 0; j < note.length - i - 1; j++) {
      if (note[j] > note[j + 1]) {
        int tmp = note[j];  
        note[j] = note[j + 1];
        note[j + 1] = tmp;
      }
    }
  }

  print("\n");
  for (int i = 0; i < note.length; i++)
    print(note[i] + ", ");

  print("\n");


  int channel = 0; // 0 <= channel <= 15
  int register = 0;
  for (int r = 0; r < 3; r++) {
    register += 12 * r;
    for (int i = 0; i < note.length; i++) {
      int pitch = note[i] + 60 + register; // E4 == 64
      int velocity = 127; // 0 <= velocity <= 127

      mBus.sendNoteOn(channel, pitch, velocity); // Send a Midi noteOn
      delay(200);
      mBus.sendNoteOff(channel, pitch, velocity); // Send a Midi nodeOff
      delay(100);
    }
  }
}
