/* Gamelan -- totally fake Gamelan piece consisting of two sections */

import themidibus.*; //Import the library

MidiBus mBus; // The MidiBus
int instrument = 0;
void setup() {
  size(400, 400);
  background(0);
  MidiBus.list();
  // mBus = new MidiBus(this, -1, "Microsoft GS Wavetable Synth");
  // mBus = new MidiBus(this, -1, "Java Sound Synthesizer");
  // mBus = new MidiBus(this, -1, "SimpleSynth virtual input");
  mBus = new MidiBus(this, -1, "Bus 1");
  noLoop();
}

void draw() {
  background(0);

  byte data[] = new byte[2];
  data[0] = (byte)0xC0; // C0hex = MIDI program change
  data[1] = (byte)9; // 9 = Glockenspiel
  // data[1] = (byte)11; // 11 = Vibraphone
  mBus.sendMessage(data);

  print("\n");

  /* Slendro: a scale of Gamelan 
   1   C# +10 cents   280Hz: MIDI nn 61
   2   D# +40 cents   318Hz: MIDI nn 63
   3   F# -20 cents   366Hz: MIDI nn 66 
   5   G# +15 cents   412Hz: MIDI nn 68
   6   A# -40 cents   483Hz: MIDI nn 70
   */

  int channel = 0; // 0 <= channel <= 15
  int velocity = 127; // 0 <= velocity <= 127
  int [] pitches = {61, 63, 66, 68, 70};
  double startSection = 0.0;

  for (int i = 0; i < 10; i++) {
    double rr = random(0.0, 1.0);

    if (0 <= rr && rr < 0.5) { /* === Section A === */
      int noOfNotes = 20;
      for (int ii = 0; ii < noOfNotes; ii++) {
        // 1st beat
        int r1 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r1], velocity); // Send a Midi noteOn
        int r2 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r2], velocity);
        int r3 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r3]-12, velocity);
        int r4 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r4]-24, velocity);

        delay(150);
        // 2nd beat       
        mBus.sendNoteOff(channel, pitches[r1], velocity); // Send a Midi nodeOff
        r1 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r1], velocity); // Send a Midi noteOn

        delay(150);
        // 3rd beat       
        mBus.sendNoteOff(channel, pitches[r1], velocity); // Send a Midi nodeOff
        r1 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r1], velocity); // Send a Midi noteOn
        r2 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r2], velocity);

        delay(150);
        // 4th beat       
        mBus.sendNoteOff(channel, pitches[r1], velocity); // Send a Midi nodeOff
        r1 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r1], velocity); // Send a Midi noteOn

        delay(150);
        // 5th beat
        mBus.sendNoteOff(channel, pitches[r1], velocity); // Send a Midi nodeOff
        mBus.sendNoteOff(channel, pitches[r2], velocity);
        r1 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r1], velocity); // Send a Midi noteOn
        r2 = int(random(0, 5));
        mBus.sendNoteOn(channel, pitches[r2], velocity);

        delay(150);
        mBus.sendNoteOff(channel, pitches[r1], velocity); // Send a Midi nodeOff
}
    } else { /* === Section B === */
      int noOfNotes = 10;
      for (int ii = 0; ii < noOfNotes; ii++) {
        int r1 = int(random(0, 5.1));
        mBus.sendNoteOn(channel, pitches[r1]-12, velocity);
        mBus.sendNoteOn(channel, pitches[r1]-12+7, velocity);
        int r2 = int(random(0, 5.1));
        mBus.sendNoteOn(channel, pitches[r2]-24, velocity);
        mBus.sendNoteOn(channel, pitches[r2]-24+7, velocity);
        delay(600);
        mBus.sendNoteOff(channel, pitches[r1]-12, velocity);
        mBus.sendNoteOff(channel, pitches[r1]-12+7, velocity);
        r1 = int(random(0, 5.1));
        mBus.sendNoteOn(channel, pitches[r1]-12, velocity);
        mBus.sendNoteOn(channel, pitches[r1]-12+7, velocity);
        delay(600);
        mBus.sendNoteOff(channel, pitches[r2]-24, velocity);
        mBus.sendNoteOff(channel, pitches[r2]-24+7, velocity);
      }
    }
  }
}
