import themidibus.*; //Import the library

MidiBus mBus; // The MidiBus
int instrument = 0;
void setup() {
  size(400,400);
  background(0);
  MidiBus.list();
  // mBus = new MidiBus(this, -1, "Microsoft GS Wavetable Synth");
  // mBus = new MidiBus(this, -1, "Java Sound Synthesizer");
  // mBus = new MidiBus(this, -1, "SimpleSynth virtual input");
  mBus = new MidiBus(this, -1, "Bus 1");
  noLoop();
}

void draw() {
  background(0);

  byte data[] = new byte[2];
  data[0] = (byte)0xC0; // C0hex = MIDI program change
  data[1] = (byte)106; // 0 = Acoustic Grand Piano
//  data[1] = (byte)55; // 55 = Orchesta Hit
  mBus.sendMessage(data);

  print("\n");

  int channel = 0; // 0 <= channel <= 15
  int pitch1 = 64; // E4 == 64
  int velocity = 127; // 0 <= velocity <= 127
 
  for(int start = 0; start < 40; start++) {
        float r1 = random(0.0, 1.0);

        if(0.0 <= r1 && r1 < 0.166) // 0.125 = 1/8
          pitch1 = 60;
        else if(0.166 <= r1 && r1 < 0.332) // 0.375 = 3/8
          pitch1 = 64;
        else if(0.332 <= r1 && r1 < 0.498) // 0.5 = 4/8
          pitch1 = 65;
        else if (0.664 <= r1 && r1 < 0.830) // 0.625 = 5/8
          pitch1 = 67;
        else if (0.830 <= r1 && r1 < 0.996) // 0.875 = 7/8
          pitch1 = 71;
        else
          pitch1 = 72;
                
    print(pitch1 + " ");

    mBus.sendNoteOn(channel, pitch1, velocity); // Send a Midi noteOn
    delay(150);
    mBus.sendNoteOff(channel, pitch1, velocity); // Send a Midi nodeOff
    delay(100);
  }
  print("\n");
}