import themidibus.*; //Import the library

MidiBus mBus; // The MidiBus
int instrument = 0;
void setup() {
  size(400,400);
  background(0);
  MidiBus.list();
  mBus = new MidiBus(this, -1, "Microsoft GS Wavetable Synth");
  // mBus = new MidiBus(this, -1, "Java Sound Synthesizer");
  // mBus = new MidiBus(this, -1, "SimpleSynth virtual input");
  // mBus = new MidiBus(this, -1, "Bus 1");
  noLoop();
}

void draw() {
  background(0);

  byte data[] = new byte[2];
  data[0] = (byte)0xC0; // C0hex = MIDI program change
  data[1] = (byte)0; // 0 = Acoustic Grand Piano
//  data[1] = (byte)55; // 55 = Orchesta Hit
  mBus.sendMessage(data);

  print("\n");

  int channel = 0; // 0 <= channel <= 15
  int pitch = 64; // E4 == 64
  int velocity = 127; // 0 <= velocity <= 127
 
  for(int start = 0; start < 20; start++) {
        float r = random(0.0, 1.0);

        if(0.0 <= r && r < 0.125) // 0.125 = 1/8
          pitch = 60;
        else if(0.125 <= r && r < 0.25) // 0.25 = 2/8
          pitch = 62;
        else if(0.25 <= r && r < 0.375) // 0.375 = 3/8
          pitch = 64;
        else if(0.375 <= r && r < 0.5) // 0.5 = 4/8
          pitch = 65;
        else if (0.5 <= r && r < 0.625) // 0.625 = 5/8
          pitch = 67;
        else if (0.625 <= r && r < 0.75) // 0.75 = 6/8
          pitch = 69;
        else if (0.75 <= r && r < 0.875) // 0.875 = 7/8
          pitch = 71;
        else
          pitch = 72;
                
    print(pitch + " ");

    mBus.sendNoteOn(channel, pitch, velocity); // Send a Midi noteOn
    delay(200);
    mBus.sendNoteOff(channel, pitch, velocity); // Send a Midi nodeOff
    delay(100);
  }
  print("\n");
}